/*
 * Copyright 2013 (c) Anna Schumaker.
 */
#include <core/queue.h>
#include <core/string.h>
#include <stdlib.h>


static inline void *__queue_init(struct queue *queue, void *data)
{
	if (queue->q_ops)
		return queue->q_ops->qop_init(queue, data);
	return NULL;
}

void queue_init(struct queue *queue, const struct queue_ops *ops, void *data)
{
	queue->q_ops    = ops;
	queue->q_private = __queue_init(queue, data);
}
